// ProgressWnd.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CProgressWnd window

#define PW_SIZE_BORDER	8

#define PW_WIDTH_DEFAULT	(UINT)-1

// Bar styles.
#define PW_BARSTYLE_FIRST	0

#define PW_BARSTYLE_FLAT	0
#define PW_BARSTYLE_SUNKEN	1
#define PW_BARSTYLE_RAISED	2

#define PW_BARSTYLE_LAST	2

// Fill colour.
#define PW_FILLCOLOUR_DEFAULT	(COLORREF)-1

class CProgressWnd : public CFrameWnd
{
// Construction
public:
	BOOL IsShowing(void);
	UINT GetCurrentPercentScale(void);
	void SetCancelText(CString strText);
	void SetFillColour(COLORREF dwColour);
	void SetWidth(UINT uWidth);
	void SetAnimationFile(CString strAVI);
	void SetBarStyle(UINT uStyle);
	void SetCancelMessage(UINT uMessage);
	BOOL WasCancelled(void);
	void SetCanCancelFlag(BOOL bCanCancel);
	void UpdateProgress(UINT uCount = 1);
	void ResetProgress(void);
	void SetFullScale(UINT uFullScale);
	void Hide(void);
	void Show(CWnd *pWndOwner = NULL);
	void SetMessage(CString strMessage, BOOL bResizeToFit = TRUE);
	void SetTitle(CString strTitle);
	CProgressWnd();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CProgressWnd)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CProgressWnd();

	// Generated message map functions
protected:
	//{{AFX_MSG(CProgressWnd)
	afx_msg void OnPaint();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnCancel(void);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	COLORREF m_dwFillColour;
	CAnimateCtrl * m_pAnimation;
	CString m_strAnimationAVI;
	CFont m_fntMessage;
	BOOL m_bWasCancelled;
	UINT m_uCancelMessage;
	CButton * m_pBtnCancel;
	BOOL m_bCanCancel;
	void ClearBar(void);
	UINT m_uLastPosition;
	void DrawBar(BOOL bForce = FALSE);
	UINT m_uBarStyle;
	UINT m_uCurrentValue;
	UINT m_uFullScale;
	CWnd * m_pWndOwner;
	HCURSOR m_hCur;
	CString m_strWndClass;
	CSize m_sizScreen;
	UINT m_uWidth;
	CRect m_rctMessage;
	CRect m_rctBar;
	void CalculateSizes(void);
	CString m_strMessage;
	CString m_strTitle;
};

/////////////////////////////////////////////////////////////////////////////
